import serial
import time
import sys
import os

# V1.0, June 2013

def main(args):
   filepath = args[0]
   dirname = filepath;
   fileparts = os.path.split(filepath)

   if len(fileparts) == 2:
      dirname = fileparts[1]

   dirparts = dirname.split('.')
   if len(dirparts) == 2:
      dirname = dirparts[0]

   if not os.path.exists(dirname):
      os.makedirs(dirname)

   with open(args[0], 'rb') as image:
      data = bytearray(image.read())

      os.chdir(dirname)

      directory = data[0x2800:0x2800+0x800]
      for x in xrange(64):
         entry = directory[x*32:x*32+32]
         if entry[0] != 0xe5:
            #print respr(entry[0])
            name = ''
            for y in xrange(8):
               name = name + chr(entry[y+1])
            name += '.'
            for y in xrange(3):
               name = name + chr(entry[y+9] & 127)
            parts = name.split()
            if (len(parts) == 2):
               name = parts[0] + parts[1]
            print name
            if entry[9] > 128:
               print '*',
            else:
               print ' ',

            extent = entry[12]
            print extent,
            
            recordcount = entry[15]
            print recordcount

            outfile = open(name, 'wb')
            idx = 0
            for y in xrange(8):
               startblock = entry[idx + 16] + 256 * entry[idx + 17]
               if startblock == 0:
                  break

               print hex(startblock),

               offs = 0x2800 + (0x800 * startblock)
               chunk = data[offs:offs+2048]
               outfile.write(chunk)

               idx = idx + 2

            outfile.seek(recordcount*128)
            outfile.truncate()
            outfile.close()
            print


if __name__ == '__main__':
   main(sys.argv[1:])
